from ipywidgets import (
    Widget, DOMWidget, widget_serialization, register
)
from ipywidgets.widgets.trait_types import TypedTuple
from traitlets import (
    Unicode, Int, CInt, Instance, ForwardDeclaredInstance, This, Enum,
    Tuple, List, Dict, Float, CFloat, Bool, Union, Any,
)

from .._base.Three import ThreeWidget
from .._base.uniforms import uniforms_serialization
from ..enums import *
from ..traits import *

from .Material import Material


@register
class LineDashedMaterial(Material):
    """LineDashedMaterial

    Autogenerated by generate-wrappers.js
    See https://threejs.org/docs/#api/materials/LineDashedMaterial
    """

    _model_name = Unicode('LineDashedMaterialModel').tag(sync=True)

    color = Color("#ffffff", allow_none=False).tag(sync=True)

    lights = Bool(False, allow_none=False).tag(sync=True)

    linewidth = IEEEFloat(1, allow_none=False).tag(sync=True)

    scale = IEEEFloat(1, allow_none=False).tag(sync=True)

    dashSize = IEEEFloat(3, allow_none=False).tag(sync=True)

    gapSize = IEEEFloat(1, allow_none=False).tag(sync=True)

    type = Unicode("LineDashedMaterial", allow_none=False).tag(sync=True)


import inspect
# Include explicit signature since the metaclass screws it up
LineDashedMaterial.__signature__ = inspect.signature(LineDashedMaterial.__init__)
